
Public Support - Support Request #15761

Open of adtf session without using batch/shell from adtf_conan_generator

2021-11-17 10:30 - hidden

Status: Closed   
Category:    
Numbers:
Requester's Priority: Normal Platform: Windows 10 64bit

Support Level: 2nd Level Topic: ADTF::CE

Resolution: Product Issue Opened FAQ Links:  

Description

Supportanfrage

Ich habe eine Frage zu Projekten in ADTF3. Wir benutzen ein Config-Template, das uns eine leeres ADTF3-Projekt generiert. Wenn

ich diese generierte Config nun in ADTF über die "open project"-Oberfläche öffne indem ich das .adtfproject-File auswähle,

bekomme ich viele Fehler:
Wenn ich allerdings die generierte Config mit Conan lokal baue und dann mit Conan und dem ADTF3Generator wieder installiere

und über das start_ce.bat-File öffne, erscheinen keine Fehler.

Dieses Verhalten wurde auch bereits von anderen Kollegen beobachtet, die den ADTF3Generator verwenden. Das Problem tritt wohl

meist im Zusammenhang mit Configs auf.

Gibt es eine Möglichkeit die Projekte nicht nur über das Start-Skript zu öffnen?

Lösung

Der adtf_conan_generator ist leider noch nicht ausreichend bis gar nicht dokumentiert, deshalb will ich dich mal kurz abholen:

Das Problem am Conan, verschiedenen Rechner in Kombination mit ADTF, Erweiterungen und und und sind die sich zu

unterscheidenden Systeme.

Deshalb muss der Configuration Editor so bedatet werden, dass er weiß wo die relevanten Daten liegen (v.a. adtfplugin bzw. deren

plugindescriptions).

Am Ende soll eine ADTF Session herausspringen, die einen ADTF Graph (Daten/Kontrolfluss) sowie das ADTF System

(Funktionalität und die relevanten adtfplugins) beschreibt.

Das ganze soll plattform unabhängig sein, womit Makros und Co ins Spiel kommen.

Nun braucht man noch eine Basis, die sowohl zur Konfigurationszeit (Configuration Editor) als auch zur Laufzeit (Launcher)

systemunabhängig funktioniert - adtf adtfenvironment File.

Das musst du enstprechend konfigurieren/generieren, dann kannst du es im CE und Launcher verwenden und alles wird gefunden.

Und genau diese Komplexität soll dir der adtf_conan_generator abnehmen, generiert dir das File, auch Session und Project und

entsprechende Startskripte, dass die relevanten Daten mitgeladen werden.

Wenn du das adtfenvironment file hast, kannst du den CE auch so starten, entweder gleich mit angeben in der Kommandozeile oder

in den Options setzen.

Dann funktioniert auch dein Projekt, was anders macht das batch Skript nicht (schau mal rein am besten).

Kannst du nun nachvollziehen, warum die Fehlermeldungen kommen und was du tun musst bzw. müsstest, um den Generator zu

ersetzen ?

PS: Details zum Use des adtfenviornment Files findest du hier:

https://support.digitalwerk.net/adtf/v3/guides/set_up_adtfenvironment.html

Ich finde aber den erweiterten Ansatz nicht schlecht, dass man im adtfprojct/adtfsession/adtfsystem diese Info (Basisvoraussetzung)

hinterlegt, man muss dann nur aufpassen, dass man auch noch ein anderes adtfenvironment verwenden, ansonsten lassen sich

Sessions ggf. nicht erweitern aus dem CE heraus.

Ich habe ein Produktticket erstellt, hier soll im neuen Jahr eine Idee dazu bewertet und umgesetzt werden:
[ACORE-11318] - Define a connection between project/session related files and adtfenvironment

History

#1 - 2021-11-17 11:56 - hidden

- Project changed from Public Support to 30

- Status changed from New to In Progress

- Customer set to CARIAD

- Department set to G3-6

- Affected Products ADTF 3.12.7 added

- Platform Windows 10 64bit added

#2 - 2021-11-17 11:56 - hidden

- Description updated

#5 - 2021-11-19 15:10 - hidden

- Description updated

- Status changed from In Progress to Customer Feedback Required

- Topic set to ADTF::CE

Hallo Daniela,

der adtf_conan_generator ist leider noch nicht ausreichend bis gar nicht dokumentiert, deshalb will ich dich mal kurz abholen:

Das Problem am Conan, verschiedenen Rechner in Kombination mit ADTF, Erweiterungen und und und sind die sich zu unterscheidenden Systeme.

Deshalb muss der Configuration Editor so bedatet werden, dass er weiß wo die relevanten Daten liegen (v.a. adtfplugin bzw. deren

plugindescriptions).

Am Ende soll eine ADTF Session herausspringen, die einen ADTF Graph (Daten/Kontrolfluss) sowie das ADTF System (Funktionalität und die

relevanten adtfplugins) beschreibt.

Das ganze soll plattform unabhängig sein, womit Makros und Co ins Spiel kommen.

Nun braucht man noch eine Basis, die sowohl zur Konfigurationszeit (Configuration Editor) als auch zur Laufzeit (Launcher) systemunabhängig

funktioniert - adtf adtfenvironment File.

Das musst du enstprechend konfigurieren/generieren, dann kannst du es im CE und Launcher verwenden und alles wird gefunden.

Und genau diese Komplexität soll dir der adtf_conan_generator abnehmen, generiert dir das File, auch Session und Project und entsprechende

Startskripte, dass die relevanten Daten mitgeladen werden.

Wenn du das adtfenvironment file hast, kannst du den CE auch so starten, entweder gleich mit angeben in der Kommandozeile oder in den Options

setzen.

Dann funktioniert auch dein Projekt, was anders macht das batch Skript nicht (schau mal rein am besten).

Kannst du nun nachvollziehen, warum die Fehlermeldungen kommen und was du tun musst bzw. müsstest, um den Generator zu ersetzen ?

PS: Details zum Use des adtfenviornment Files findest du hier:

https://support.digitalwerk.net/adtf/v3/guides/set_up_adtfenvironment.html

#6 - 2021-11-22 11:53 - hidden

Mein Kommentar als "Außenstehender": Wie du schon sagst Florian, das adtfproject ist eigentlich nur zusammen mit der adtfenvironment nutzbar.

Also sollte sich der CE auch merken, welche die letzte genutzte adtfenvironment eines Projektes war. Ansonsten ergeben die "Recent Projects" und

auch "Open Project" nur bedingt Sinn.

#7 - 2021-11-22 12:03 - hidden

@Marc: Deine Aussage ist nur bedingt richtig, ein adtfenvironment beschreibt die Basis für n-Projekte.

Im normalen Fall ist ein adtfenvironment definiert, dass alle Abhängigkeiten definiert, die man zum Erstellen eines Projektes haben kann (also der

gesamte Pool).

Mit Conan Generator schränkst du das generierte File aber ein, sprich nur das was du am Ende auch haben möchtest, also streng genommen ein

erweitertes adtfsystem File.

Das ist nicht die eigentliche Intentionm, deshalb wird das adtfenvironment auch im cesettings File gespeichert und nicht im adtfproject.

Ich finde aber den erweiterten Ansatz nicht schlecht, dass man im adtfprojct diese Info (Basisvoraussetzung) hinterlegt, man muss dann nur

aufpassen, dass man auch noch ein anderes adtfenvironment verwenden, ansonsten lassen sich Sessions ggf. nicht erweitern aus dem CE heraus.

#8 - 2021-11-22 12:08 - hidden

Nachtrag:

Vermutlich müsste es wenn dann in der adtfsession abgelegt werden, da diese auch zur Laufzeit existiert.
Muss evaluiert werden.

#9 - 2021-11-22 13:06 - hidden

@Florian: Die benutzte Environment in eine der Dateien (session, project) mit einzutragen ist sicherlich das angenehmste. Ich könnte mir aber auch

vorstellen, dass sich nur der CE in einer permanenten Liste merkt, welches die letzte Env zu einem Projekt war und diese dann auswählt, wenn das

Projekt geöffnet wird. Das wäre nicht so intrusive.

#10 - 2021-11-22 13:27 - hidden

@Marc: Ist auch ein Ansatz, dann verlierst du aber den Charme, dass es immer geht. Dann muss zwangsläufig das Projekt schon einmal mit dem

passenden Enironment geladen worden sein.

Wenn wir die Info ablegen, könnte man beim Öffnen mit einer Option, checkbox (oder allgemeinen setting) arbeiten, zb

load_project_related_adtfenvironment oder andersrum use_always_current_adtfenvironment o.ä.

#13 - 2021-11-26 09:49 - hidden

- Project changed from 30 to Public Support

- Subject changed from ADTF3 Config ohne start_ce_.bat öffnen to Open of adtf session without using batch/shell from adtf_conan_generator

- Description updated

- Status changed from Customer Feedback Required to To Be Closed

- Private changed from Yes to No

- Resolution set to Product Issue Opened

- Product Issue Numbers set to https://www.cip.audi.de/jira/browse/ACORE-11318

Ich habe ein Produktticket erstellt, hier soll im neuen Jahr eine Idee dazu bewertet und umgesetzt werden:

[ACORE-11318] - Define a connection between project/session related files and adtfenvironment

#15 - 2022-01-17 08:17 - hidden

- Status changed from To Be Closed to Closed
